/* Creation of a simple Windows API program */

#include <windows.h>
#include <stdio.h>
#include <math.h>

/*  Declare Windows procedure  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);

/*  Make the class name into a global variable  */
char szClassName[ ] = "WindowsApp";

/*
int WINAPI
WinMain (HINSTANCE hThisInstance,
         HINSTANCE hPrevInstance,
         LPSTR lpszArgument,
         int nFunsterStil)
*/

HDC dc;

#define WIDTH 544
#define HEIGHT 375

unsigned int width, height;

int init_graph (HINSTANCE hThisInstance,
         HINSTANCE hPrevInstance,
         LPSTR lpszArgument,
         int nFunsterStil)
{
    HWND hwnd;               /* This is the handle for our window */
    MSG messages;            /* Here messages to the application are saved */
    WNDCLASSEX wincl;        /* Data structure for the windowclass */

    width = WIDTH;
    height = HEIGHT;

    /* The Window structure */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = szClassName;
    wincl.lpfnWndProc = WindowProcedure;      /* This function is called by windows */
    wincl.style = CS_DBLCLKS;                 /* Catch double-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Use default icon and mouse-pointer */
    wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL;                 /* No menu */
    wincl.cbClsExtra = 0;                      /* No extra bytes after the window class */
    wincl.cbWndExtra = 0;                      /* structure or the window instance */
    /* Use Windows's default color as the background of the window */
    wincl.hbrBackground = (HBRUSH) COLOR_BACKGROUND;

    /* Register the window class, and if it fails quit the program */
    if (!RegisterClassEx (&wincl))
        return 0;

    /* The class is registered, let's create the program*/
    hwnd = CreateWindowEx (
           0,                   /* Extended possibilites for variation */
           szClassName,         /* Classname */
           "Windows App",       /* Title Text */
           WS_OVERLAPPEDWINDOW, /* default window */
           CW_USEDEFAULT,       /* Windows decides the position */
           CW_USEDEFAULT,       /* where the window ends up on the screen */
           WIDTH,                 /* The programs width */
           HEIGHT,                 /* and height in pixels */
           HWND_DESKTOP,        /* The window is a child-window to desktop */
           NULL,                /* No menu */
           hThisInstance,       /* Program Instance handler */
           NULL                 /* No Window Creation data */
           );

    /* Make the window visible on the screen */
    ShowWindow (hwnd, nFunsterStil);
 
    dc = GetDC (hwnd);
    return 1;
}


/*
    { 
     HDC dc;
     int i;
     int x, y;
     char buf[100];
     dc = GetDC (hwnd);
     for (i=1;;i++)
     {
      printf ("x ? ");     
      gets (buf);
      x = atoi(buf);
      if (x==0) break;
      printf ("y ? ");
      gets (buf);
      y = atoi(buf);
      SetPixel (dc, x, y, 0);
      sprintf (buf, "%d", i);
      TextOut (dc, x, y, buf, strlen(buf));
     }

     for (i=0; i<1000; i++)
     {
      SetPixel (dc, 100+80*sin(3*i), 100+80*sin(4*i), 0);
     }
     gets(buf);
   
    }

    return 0;
    */

void plot (int x, int y)
{
 SetPixel (dc, x, y, 0);
}

void draw_string (int x, int y, char *s)
{
  TextOut (dc, x, y, s, strlen(s));
}
#if 0   
    /* Run the message loop. It will run until GetMessage() returns 0 */
    while (GetMessage (&messages, NULL, 0, 0))
    {
        /* Translate virtual-key messages into character messages */
        TranslateMessage(&messages);
        /* Send message to WindowProcedure */
        DispatchMessage(&messages);
    }

    /* The program return-value is 0 - The value that PostQuitMessage() gave */
    return messages.wParam;
#endif
/*}*/


/*  This function is called by the Windows function DispatchMessage()  */

LRESULT CALLBACK
WindowProcedure (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch (message)                  /* handle the messages */
    {
        case WM_DESTROY:
            PostQuitMessage (0);       /* send a WM_QUIT to the message queue */
            break;
        default:                      /* for messages that we don't deal with */
            return DefWindowProc (hwnd, message, wParam, lParam);
    }

    return 0;
}

int WINAPI
WinMain1 (HINSTANCE hThisInstance,
         HINSTANCE hPrevInstance,
         LPSTR lpszArgument,
         int nFunsterStil)
{
int t, x, y;
char buf[10];
 init_graph (hThisInstance, hPrevInstance, lpszArgument, nFunsterStil);

 plot (210, 40);
 draw_string (210, 40, "Bonjour !");
 
 for (t=0; t<1000; t++)
 {
  x = 100+90*sin((float)(t*t)/5);
  y = 100+90*cos((float)t/6);
  /* printf ("%d %d\n", x, y); */
  plot (x, y);
 }

 gets(buf);
 return 0;
}
